// ==============================================================
// RTL generated by Vivado(TM) HLS - High-Level Synthesis from C, C++ and SystemC
// Version: 2019.1
// Copyright (C) 1986-2019 Xilinx, Inc. All Rights Reserved.
// 
// ===========================================================

#ifndef _hls_macc_HH_
#define _hls_macc_HH_

#include "systemc.h"
#include "AESL_pkg.h"

#include "hls_macc_dadddsub_64ns_64ns_64_16_full_dsp_1.h"
#include "hls_macc_dmul_64ns_64ns_64_18_max_dsp_1.h"
#include "hls_macc_sitodp_32ns_64_8_1.h"
#include "hls_macc_HLS_MACC_PERIPH_BUS_s_axi.h"

namespace ap_rtl {

template<unsigned int C_S_AXI_HLS_MACC_PERIPH_BUS_ADDR_WIDTH = 6,
         unsigned int C_S_AXI_HLS_MACC_PERIPH_BUS_DATA_WIDTH = 32>
struct hls_macc : public sc_module {
    // Port declarations 20
    sc_in_clk ap_clk;
    sc_in< sc_logic > ap_rst_n;
    sc_in< sc_logic > s_axi_HLS_MACC_PERIPH_BUS_AWVALID;
    sc_out< sc_logic > s_axi_HLS_MACC_PERIPH_BUS_AWREADY;
    sc_in< sc_uint<C_S_AXI_HLS_MACC_PERIPH_BUS_ADDR_WIDTH> > s_axi_HLS_MACC_PERIPH_BUS_AWADDR;
    sc_in< sc_logic > s_axi_HLS_MACC_PERIPH_BUS_WVALID;
    sc_out< sc_logic > s_axi_HLS_MACC_PERIPH_BUS_WREADY;
    sc_in< sc_uint<C_S_AXI_HLS_MACC_PERIPH_BUS_DATA_WIDTH> > s_axi_HLS_MACC_PERIPH_BUS_WDATA;
    sc_in< sc_uint<C_S_AXI_HLS_MACC_PERIPH_BUS_DATA_WIDTH/8> > s_axi_HLS_MACC_PERIPH_BUS_WSTRB;
    sc_in< sc_logic > s_axi_HLS_MACC_PERIPH_BUS_ARVALID;
    sc_out< sc_logic > s_axi_HLS_MACC_PERIPH_BUS_ARREADY;
    sc_in< sc_uint<C_S_AXI_HLS_MACC_PERIPH_BUS_ADDR_WIDTH> > s_axi_HLS_MACC_PERIPH_BUS_ARADDR;
    sc_out< sc_logic > s_axi_HLS_MACC_PERIPH_BUS_RVALID;
    sc_in< sc_logic > s_axi_HLS_MACC_PERIPH_BUS_RREADY;
    sc_out< sc_uint<C_S_AXI_HLS_MACC_PERIPH_BUS_DATA_WIDTH> > s_axi_HLS_MACC_PERIPH_BUS_RDATA;
    sc_out< sc_lv<2> > s_axi_HLS_MACC_PERIPH_BUS_RRESP;
    sc_out< sc_logic > s_axi_HLS_MACC_PERIPH_BUS_BVALID;
    sc_in< sc_logic > s_axi_HLS_MACC_PERIPH_BUS_BREADY;
    sc_out< sc_lv<2> > s_axi_HLS_MACC_PERIPH_BUS_BRESP;
    sc_out< sc_logic > interrupt;
    sc_signal< sc_logic > ap_var_for_const0;


    // Module declarations
    hls_macc(sc_module_name name);
    SC_HAS_PROCESS(hls_macc);

    ~hls_macc();

    sc_trace_file* mVcdFile;

    ofstream mHdltvinHandle;
    ofstream mHdltvoutHandle;
    hls_macc_HLS_MACC_PERIPH_BUS_s_axi<C_S_AXI_HLS_MACC_PERIPH_BUS_ADDR_WIDTH,C_S_AXI_HLS_MACC_PERIPH_BUS_DATA_WIDTH>* hls_macc_HLS_MACC_PERIPH_BUS_s_axi_U;
    hls_macc_dadddsub_64ns_64ns_64_16_full_dsp_1<1,16,64,64,64>* hls_macc_dadddsub_64ns_64ns_64_16_full_dsp_1_U1;
    hls_macc_dmul_64ns_64ns_64_18_max_dsp_1<1,18,64,64,64>* hls_macc_dmul_64ns_64ns_64_18_max_dsp_1_U2;
    hls_macc_sitodp_32ns_64_8_1<1,8,32,64>* hls_macc_sitodp_32ns_64_8_1_U3;
    sc_signal< sc_logic > ap_rst_n_inv;
    sc_signal< sc_logic > ap_start;
    sc_signal< sc_logic > ap_done;
    sc_signal< sc_logic > ap_idle;
    sc_signal< sc_lv<60> > ap_CS_fsm;
    sc_signal< sc_logic > ap_CS_fsm_state1;
    sc_signal< sc_logic > ap_ready;
    sc_signal< sc_lv<64> > x;
    sc_signal< sc_logic > y_ap_vld;
    sc_signal< sc_lv<64> > grp_fu_84_p1;
    sc_signal< sc_lv<64> > reg_87;
    sc_signal< sc_logic > ap_CS_fsm_state10;
    sc_signal< sc_logic > ap_CS_fsm_state26;
    sc_signal< sc_lv<64> > x_read_reg_131;
    sc_signal< sc_lv<32> > zext_ln10_1_fu_97_p1;
    sc_signal< sc_lv<32> > zext_ln10_1_reg_136;
    sc_signal< sc_logic > ap_CS_fsm_state2;
    sc_signal< sc_lv<9> > add_ln11_fu_115_p2;
    sc_signal< sc_lv<9> > add_ln11_reg_144;
    sc_signal< sc_lv<1> > icmp_ln10_fu_101_p2;
    sc_signal< sc_lv<7> > i_fu_121_p2;
    sc_signal< sc_lv<7> > i_reg_149;
    sc_signal< sc_lv<32> > zext_ln11_fu_127_p1;
    sc_signal< sc_logic > ap_CS_fsm_state3;
    sc_signal< sc_lv<64> > grp_fu_75_p2;
    sc_signal< sc_lv<64> > tmp_2_reg_159;
    sc_signal< sc_lv<64> > grp_fu_80_p2;
    sc_signal< sc_lv<64> > tmp_3_reg_164;
    sc_signal< sc_logic > ap_CS_fsm_state44;
    sc_signal< sc_logic > ap_CS_fsm_state60;
    sc_signal< sc_lv<64> > s_0_reg_51;
    sc_signal< sc_lv<7> > i_0_reg_64;
    sc_signal< sc_lv<64> > grp_fu_75_p0;
    sc_signal< sc_lv<64> > grp_fu_75_p1;
    sc_signal< sc_logic > ap_CS_fsm_state11;
    sc_signal< sc_logic > ap_CS_fsm_state45;
    sc_signal< sc_logic > ap_CS_fsm_state27;
    sc_signal< sc_lv<32> > grp_fu_84_p0;
    sc_signal< sc_logic > ap_CS_fsm_state19;
    sc_signal< sc_lv<9> > zext_ln10_fu_93_p1;
    sc_signal< sc_lv<9> > shl_ln_fu_107_p3;
    sc_signal< sc_lv<2> > grp_fu_75_opcode;
    sc_signal< sc_lv<60> > ap_NS_fsm;
    static const sc_logic ap_const_logic_1;
    static const sc_logic ap_const_logic_0;
    static const sc_lv<60> ap_ST_fsm_state1;
    static const sc_lv<60> ap_ST_fsm_state2;
    static const sc_lv<60> ap_ST_fsm_state3;
    static const sc_lv<60> ap_ST_fsm_state4;
    static const sc_lv<60> ap_ST_fsm_state5;
    static const sc_lv<60> ap_ST_fsm_state6;
    static const sc_lv<60> ap_ST_fsm_state7;
    static const sc_lv<60> ap_ST_fsm_state8;
    static const sc_lv<60> ap_ST_fsm_state9;
    static const sc_lv<60> ap_ST_fsm_state10;
    static const sc_lv<60> ap_ST_fsm_state11;
    static const sc_lv<60> ap_ST_fsm_state12;
    static const sc_lv<60> ap_ST_fsm_state13;
    static const sc_lv<60> ap_ST_fsm_state14;
    static const sc_lv<60> ap_ST_fsm_state15;
    static const sc_lv<60> ap_ST_fsm_state16;
    static const sc_lv<60> ap_ST_fsm_state17;
    static const sc_lv<60> ap_ST_fsm_state18;
    static const sc_lv<60> ap_ST_fsm_state19;
    static const sc_lv<60> ap_ST_fsm_state20;
    static const sc_lv<60> ap_ST_fsm_state21;
    static const sc_lv<60> ap_ST_fsm_state22;
    static const sc_lv<60> ap_ST_fsm_state23;
    static const sc_lv<60> ap_ST_fsm_state24;
    static const sc_lv<60> ap_ST_fsm_state25;
    static const sc_lv<60> ap_ST_fsm_state26;
    static const sc_lv<60> ap_ST_fsm_state27;
    static const sc_lv<60> ap_ST_fsm_state28;
    static const sc_lv<60> ap_ST_fsm_state29;
    static const sc_lv<60> ap_ST_fsm_state30;
    static const sc_lv<60> ap_ST_fsm_state31;
    static const sc_lv<60> ap_ST_fsm_state32;
    static const sc_lv<60> ap_ST_fsm_state33;
    static const sc_lv<60> ap_ST_fsm_state34;
    static const sc_lv<60> ap_ST_fsm_state35;
    static const sc_lv<60> ap_ST_fsm_state36;
    static const sc_lv<60> ap_ST_fsm_state37;
    static const sc_lv<60> ap_ST_fsm_state38;
    static const sc_lv<60> ap_ST_fsm_state39;
    static const sc_lv<60> ap_ST_fsm_state40;
    static const sc_lv<60> ap_ST_fsm_state41;
    static const sc_lv<60> ap_ST_fsm_state42;
    static const sc_lv<60> ap_ST_fsm_state43;
    static const sc_lv<60> ap_ST_fsm_state44;
    static const sc_lv<60> ap_ST_fsm_state45;
    static const sc_lv<60> ap_ST_fsm_state46;
    static const sc_lv<60> ap_ST_fsm_state47;
    static const sc_lv<60> ap_ST_fsm_state48;
    static const sc_lv<60> ap_ST_fsm_state49;
    static const sc_lv<60> ap_ST_fsm_state50;
    static const sc_lv<60> ap_ST_fsm_state51;
    static const sc_lv<60> ap_ST_fsm_state52;
    static const sc_lv<60> ap_ST_fsm_state53;
    static const sc_lv<60> ap_ST_fsm_state54;
    static const sc_lv<60> ap_ST_fsm_state55;
    static const sc_lv<60> ap_ST_fsm_state56;
    static const sc_lv<60> ap_ST_fsm_state57;
    static const sc_lv<60> ap_ST_fsm_state58;
    static const sc_lv<60> ap_ST_fsm_state59;
    static const sc_lv<60> ap_ST_fsm_state60;
    static const sc_lv<32> ap_const_lv32_0;
    static const int C_S_AXI_DATA_WIDTH;
    static const sc_lv<32> ap_const_lv32_9;
    static const sc_lv<32> ap_const_lv32_19;
    static const sc_lv<32> ap_const_lv32_1;
    static const sc_lv<1> ap_const_lv1_0;
    static const sc_lv<32> ap_const_lv32_2;
    static const sc_lv<32> ap_const_lv32_2B;
    static const sc_lv<32> ap_const_lv32_3B;
    static const sc_lv<64> ap_const_lv64_0;
    static const sc_lv<7> ap_const_lv7_1;
    static const sc_lv<1> ap_const_lv1_1;
    static const sc_lv<32> ap_const_lv32_A;
    static const sc_lv<32> ap_const_lv32_2C;
    static const sc_lv<32> ap_const_lv32_1A;
    static const sc_lv<32> ap_const_lv32_12;
    static const sc_lv<7> ap_const_lv7_65;
    static const sc_lv<2> ap_const_lv2_0;
    static const sc_lv<2> ap_const_lv2_1;
    static const bool ap_const_boolean_1;
    // Thread declarations
    void thread_ap_var_for_const0();
    void thread_ap_clk_no_reset_();
    void thread_add_ln11_fu_115_p2();
    void thread_ap_CS_fsm_state1();
    void thread_ap_CS_fsm_state10();
    void thread_ap_CS_fsm_state11();
    void thread_ap_CS_fsm_state19();
    void thread_ap_CS_fsm_state2();
    void thread_ap_CS_fsm_state26();
    void thread_ap_CS_fsm_state27();
    void thread_ap_CS_fsm_state3();
    void thread_ap_CS_fsm_state44();
    void thread_ap_CS_fsm_state45();
    void thread_ap_CS_fsm_state60();
    void thread_ap_done();
    void thread_ap_idle();
    void thread_ap_ready();
    void thread_ap_rst_n_inv();
    void thread_grp_fu_75_opcode();
    void thread_grp_fu_75_p0();
    void thread_grp_fu_75_p1();
    void thread_grp_fu_84_p0();
    void thread_i_fu_121_p2();
    void thread_icmp_ln10_fu_101_p2();
    void thread_shl_ln_fu_107_p3();
    void thread_y_ap_vld();
    void thread_zext_ln10_1_fu_97_p1();
    void thread_zext_ln10_fu_93_p1();
    void thread_zext_ln11_fu_127_p1();
    void thread_ap_NS_fsm();
    void thread_hdltv_gen();
};

}

using namespace ap_rtl;

#endif
